import React, {useState, useEffect, useRef} from 'react'
import Stack from '@mui/material/Stack'
import Box from '@mui/material/Box'


import {connect}  from 'react-redux'

import { actionFullMsgsByChat } from '../actions'


const Msg = ({msg}) => {

   const {_id, text} = msg

   return (
      <>
         <p>
            {text}
         </p> 
      </>
   )
}


const MsgList = ({chats, chatId}) => {

   const msgArr =  chats[chatId]?.messages

   return (
      <Box>
         <Stack
            direction="column-reverse"
            justifyContent="flex-start"
            alignItems="stretch"
            spacing={2}
         >
            { msgArr ?
               msgArr.map(msg => <Msg key={msg._id} msg={msg}/>) :
                  <div>сообщений нема</div>         
            }  

         </Stack>
      </Box>
   )
}
const CMsgList = connect(state => ({chats: state.chats}))(MsgList)


const MsgListWrapp = ({match:{params:{_id}}, getData}) => {
   const [msgBlock, setMsgBlock] = useState(0)

   useEffect(() => {
      getData(_id, msgBlock, 50)
  },[_id])

   return (
      <>
         <CMsgList chatId={_id} />
      </>
   )
}
export const CMsgListWrapp= connect(null, {getData: actionFullMsgsByChat})(MsgListWrapp)